'' HTTP Remote Compiler
'' Many thanks to Harrison & BradC for doing the heaving lifting on this project!
'' Wouldn't have been possible without their help! -OBC
{{

Make required changes to the DAT & CON sections of this program.
Requires an Apache server 2.0(or higher) to work properly.

DHCP is not possible here.  Pick a free "ip_addr" which matches
your NAT pool.  Generally something .25 up is safe on most routers.

Use "ipconfig /all" from a Windows workstation to find your settings

}}

CON
  _clkmode = xtal1+pll16x
  _xinfreq = 5_000_000
  _stack   = 100
  
  '' Location of the Ethernet Card
            'Socket A        'Socket D    (Referring to Spinstudio Sockets)
   cs          = 3                '19
   sck         = 4                '20
   si          = 5                '21
   so          = 6                '22

   VideoPin    = 12
   SDPin       = 16
   KeyboardPin = 26
   
   '' IP address of the remote web server: (Example: 192.168.0.1)
   '' This is the server running Apache/BSTC
   
   remote_srv1 = 192 
   remote_srv2 = 168 
   remote_srv3 = 0'  
   remote_srv4 = 1   
   
DAT
  mac_addr      byte    $02, $00, $00, $00, $00, $01

  ip_addr       byte    192, 168, 0, 25          ' Propeller ip address
  ip_subnet     byte    255, 255, 255, 0         ' network subnet
  ip_gateway    byte    192, 168, 0, 0           ' network gateway (router)
  ip_dns        byte    192, 168, 0, 0           ' network dns

OBJ
  sock  : "driver_socket"
  http  : "api_httpclient"
  text  : "TV_Text_Half_Height"   
  sd    : "fsrw_shared"
  key   : "comboKeyboard"
  
VAR
  byte buff[32]
  byte source[20]
  byte binaryout[20]
  
PUB main | clen, chunklen, i, writeToSD,keyin,binary,sourcefile

  text.start(VideoPin,0,1,40,24)
  sock.start(cs, sck, si, so, -1,-1,@mac_addr,@ip_addr) 
  key.start(KeyboardPin)
  bytefill(@binaryout,0,16)

  \sd.mount(SDPin)  
  text.str(string($C,8," Propeller Remote Compiler: ",13))
  text.str(string($C,4," ==========================",13,13,13))
  text.str(string($C,8," Selected SOURCE ::] ",$C,2))
  text.str(string("DESKTOP.TMP",13))
  text.out(13)
  text.out(13)
  text.str(string($C,9," * Warning *  This will overwrite an ",13))
  text.str(string(" existing binary using the same name.",13,13,13))
  text.str(string($C,8,"   Select OUTPUT ::] ",$C,2))
  
  text.str(@binaryout)
  INPUT(@binaryout,13,0)
  text.out(0) 
  text.str(string($C,2,"Compiling code....",$C,8))
  text.out(13)
  text.out(13)
  delay_ms(200)

  \http.startPOSTRequest(constant((remote_srv1 << 24) + (remote_srv2 << 16) + (remote_srv3 << 8) + remote_srv4), 80, string("propserve.fwdweb.com"), string("/bstc/upload.php"))

  uploadSDFile(string("src[]"), string("desktop.tmp")) 


  clen := \http.endPOSTRequest

  
  text.str(string($C,4,"Server result code: ",$C,8))
  text.dec(clen)
  text.out(13)
  text.out(13)

  writeToSD := false
  repeat
    chunklen := \http.getResponseChunk(@buff, 32)
    if chunklen == http#ERRNOMOREDATA
      ' ran out of data
      text.str(string(13,13,$C,2,"Finished!",$C,8,13,13,"Press [",$C,2,"ENTER",$C,8,"] to reboot",13))
      keyin:=0
      repeat until keyin == 13 'Reboot when Carriage Return is pressed
         keyin := key.key 
      sd.pclose
      reboot
      quit
   
    ' print data
    repeat i from 0 to chunklen - 1
      if buff[i] == "#" and (not writeToSD)
        if \sd.popen(@binaryout, "w") => 0
          writeToSD := true
      else
        ifnot writeToSD
          if buff[i] == 10
            text.out(13)
          elseif buff[i] <> 13
            text.out(buff[i])
        else
          \sd.pputc(buff[i])
        
  if writeToSD
    \sd.pclose
  
  \http.disconnect

  repeat
    waitcnt(0)

PRI uploadSDFile(strField, strFileName) | len

  if \sd.popen(strFileName, "r") < 0
    return

  \http.startPOSTFile(strField, strFileName)
  
  repeat while (len := \sd.pread(@buff, 32)) > 0
    \http.appendPOSTFileData(@buff, len)

  \http.endPOSTFile

  \sd.pclose

PRI input(data, size,filelen) | keystroke,len
   keystroke:=0
   len:=filelen
   size:=size-filelen
   text.out(14)
   repeat' until keystroke == 13 'Exit when Carriage Return is pressed
     keystroke := key.key 
         
      if keystroke == $C8       ' Check for Backspace Key
        if len > 0
         byte[data--] := 0
         size++
         len--
         text.out(8)
         text.out(32) 'These lines erase the cursor on backspace
         text.out(8)
         
         text.out(8)
         text.out(32)
         text.out(8)
         text.out(14)
         keystroke := 0

      if keystroke == $C8        'Clean up backspace if all is cleared
         keystroke:= 0

      if keystroke == 13
         text.out(8)
         text.out(32)
         text.out(8)
         text.out(13)
         quit
         
      if keystroke > 10 
        if size > 1 and len < 15
          text.out(8)
          text.out(keystroke)
          text.out(14)
          
          ''text.dec(keystroke) 'for troubleshooting
          if keystroke <> 13 
            byte[data++] := keystroke
            size--
            len++

  
PRI delay_ms(Duration)
  waitcnt((clkfreq / 1_000 * Duration - 3932) + cnt)